src/eCommerce.BackOffice/Controllers/BankInterestController.cs
using eCommerce.Services.Model;
using eCommerce.Services.Notification;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using eCommerce.Services.Model.Enums;
using static eCommerce.Services.Utils.Utility;
using System.ComponentModel.DataAnnotations;

namespace eCommerce.BackOffice.Controllers
{
    public class BankInterestController : Controller
    {
        private DbModelEntities modelEntities = new DbModelEntities();
        //private const string BankPromotionsFileUploadDirectory = "/Content/UploadDirectory/BankPromotions";

        public ActionResult Index()
        {
            return View("BankInterestList", this.BankInterestsToList());
        }

        private List<BankInterest> BankInterestsToList()
        {
            return modelEntities.BankInterests.Where(x => !x.Deleted.HasValue).OrderBy(x => x.BankId).ThenBy(x => x.Name).ToList();
        }

        [HttpGet]
        public ActionResult BankInterestUpdate(int Id)
        {
            var banks = modelEntities.Banks.Where(x => !x.Deleted.HasValue).ToList();
            var StoreTypeList = from StoreTypeEnum publishedType in EnumUtil.GetValues<StoreTypeEnum>()
                                    select new
                                    {
                                        Id = (int)publishedType,
                                        Name = publishedType.GetAttribute<DisplayAttribute>().Name
                                    };

            if (Id != -1)
            {
                var bankInterest = modelEntities.BankInterests.FirstOrDefault(x => x.BankInterestId == Id);

                TempData["Banks"] = new SelectList(banks, "BankId", "Name", bankInterest.BankId);
                TempData["StoreType"] = new SelectList(StoreTypeList, "Id", "Name", bankInterest.StoreType);
                return View(bankInterest);
            }

            TempData["Banks"] = new SelectList(banks, "BankId", "Name");
            TempData["StoreType"] = new SelectList(StoreTypeList, "Id", "Name");
            return View(new BankInterest { BankInterestId = Id });
        }

        [HttpPost]
        public ActionResult BankInterestUpdate(FormCollection form)
        {
            BankInterest bankInterest = new BankInterest();

            if (form["BankInterestId"] != string.Empty && Convert.ToInt16(form["BankInterestId"]) > 0)
            {
                int bankInterestId = Convert.ToInt16(form["BankInterestId"]);
                bankInterest = modelEntities.BankInterests.FirstOrDefault(x => x.BankInterestId == bankInterestId && x.Deleted == null);
            }

            TryUpdateModel(bankInterest, form);

            if (bankInterest.Installments == 0)
            {
                bankInterest.Installments = 1;
            }


            if (Request["Active"] != null && Request["Active"] == "on")
                bankInterest.Active = true;
            else
                bankInterest.Active = false;

            if (bankInterest.BankInterestId <= 0)
            {
                modelEntities.BankInterests.Add(bankInterest);
            }

            modelEntities.SaveChanges();

            NotificationBar.ShowMessage(this, NotificationMessageType.Success, "Los datos fueron guardados correctamente!");
            return RedirectToAction("Index");
        }

        [HttpGet]
        public virtual PartialViewResult BankInterestDelete(int Id)
        {
            var bankInterest = modelEntities.BankInterests.FirstOrDefault(x => x.BankInterestId == Id && !x.Deleted.HasValue);
            if (bankInterest != null)
            {
                bankInterest.Deleted = CurrentDate.Now;
                bankInterest.DeletedBy = User.Identity.Name;
                modelEntities.SaveChanges();
            }

            return PartialView("_BankInterestList", this.BankInterestsToList());
        }        
    }
}

src/eCommerce.BackOffice/Views/BankInterest/BankInterestList.cshtml
@model List<eCommerce.Services.Model.BankInterest>
@{
    ViewBag.Title = "Intereses de bancos";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Intereses de bancos</h1>
    <div class="page-header-actions">
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/BankInterest/BankInterestUpdate/-1'">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVA OPCIÓN DE PAGO</span>
            </button>
        </div>
    </div>
</div>

<div class="page-content">

    <div class="panel">
        <div class="panel-body">
            @Html.Partial("_BankInterestList", Model)
        </div>
    </div>

</div>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            //setActionsDialogs();
        })

        function fDelete(Id)
        {
            $.ajax({
                url: "/BankInterest/BankInterestDelete/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR)
                {
                    $('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();
                    swal("Eliminado!", "", "success");
                }
            });
        }

        function fDeleteDialog(bankInterestId)
        {
            swal({
                title: "Confirma su acción de Eliminar?",
                text: "",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo elminarlo!',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fDelete(bankInterestId);
                }
            });
        }

        function setActionsDialogs()
        {
            $('.remove-row').on("click", function () {
                
            });
        }

    </script>

}

src/eCommerce.BackOffice/Views/BankInterest/BankInterestUpdate.cshtml
@model eCommerce.Services.Model.BankInterest
@{
    ViewBag.Title = "Promoción con tarjeta";
	Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Promoción con tarjeta</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("BankInterestUpdate", "BankInterest", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off" }))
                    {
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Nombre</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Name" id="Name" value="@Model.Name" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Banco</label>
                            <div class="col-sm-9">
                                <select class="form-control" name="BankId" id="BankId" data-plugin="select2">
                                    @if (TempData["Banks"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Banks"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Número de cuotas</label>
                            <div class="col-sm-9">
                                <input type="number" max="99" class="form-control" name="Installments" value="@(Model.Installments)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Interés</label>
                            <div class="input-group col-sm-9">
                                <span class="input-group-addon">%</span>
                                <input type="text" class="form-control" name="Percent" value="@(Model.Percent)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Orden</label>
                            <div class="col-sm-9">
                                <input type="number" max="99" class="form-control" name="DisplayOrder" value="@(Model.DisplayOrder)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-sm-2">Fecha desde</label>
                            <div class="input-group col-sm-9">
                                <span class="input-group-addon">
                                    <i class="icon wb-calendar" aria-hidden="true"></i>
                                </span>
                                <input type="text" class="form-control DateInput" name="FromDate" value="@(Model.FromDate != DateTime.MinValue ? Model.FromDate.ToShortDateString():string.Empty)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-sm-2">Fecha hasta</label>
                            <div class="input-group col-sm-9">
                                <span class="input-group-addon">
                                    <i class="icon wb-calendar" aria-hidden="true"></i>
                                </span>
                                <input type="text" class="form-control DateInput" name="ToDate" value="@(Model.ToDate != DateTime.MinValue ? Model.ToDate.ToShortDateString():string.Empty)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Tipo Publicado</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="StoreType" id="StoreType" data-plugin="select2">
                                    @if (TempData["StoreType"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["StoreType"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Monto Mínimo</label>
                            <div class="col-sm-9">
                                <input type="number" class="form-control" name="MinimumAmount" id="MinimumAmount" value="@(Model.MinimumAmount)" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Activo</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="Active" id="Active" class="js-switch-small" data-plugin="switchery" data-size="small" @(Model.Active ? "checked=\"checked\"" : "") data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>
                        <div class="text-right">
                            <button type="submit" class="btn btn-success" onclick="save()"><i class="icon wb-check" aria-hidden="true"></i> Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/BankInterest'">Cancelar</button>
                            @Html.HiddenFor(model => model.BankInterestId)
                        </div>
                        <input hidden="hidden" name="flagDelete" id="flagDelete" value="false" />
                    }
                </div>
            </div>
        </div>
    </div>
</div>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Name: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Nombre es requerido.'
                            }
                        }
                    },
                    Benefit: {
                        validators: {
                            numeric: {
                                message: 'Ingrese un valor correcto.',
                                separator: ','
                            }
                        }
                    }
                }
            });
        })();

        $('.DateInput').datepicker({
            format: "dd/mm/yyyy",
            language: "es",
            autoclose: true,
            todayHighlight: true
        });

    </script>
}

src/eCommerce.BackOffice/Views/BankInterest/_BankInterestList.cshtml
@model List<eCommerce.Services.Model.BankInterest>
@using eCommerce.Services.Model.Enums

<table class="table table-hover dataTable table-striped width-full" data-plugin="dataTable">
    <thead>
        <tr>
            <th>Nombre</th>
            <th>Banco</th>
            <th class="text-center">Cuotas</th>
            <th class="text-center">Monto Mínimo</th>
            <th class="text-center">Recargo</th>
            <th class="text-center">Orden</th>
            <th class="text-center">Vigente</th>
            <th class="text-center">Activo</th>
            <th class="text-center">Tienda</th>
            <th class="col-xs-2 text-center">Acciones</th>
        </tr>
    </thead>
    <tbody>
    @foreach (var item in Model)
    {
        <tr>
            <td>@item.Name</td>
            <td>@item.Bank.Name</td>
            <td class="text-center">@item.Installments</td>
            <td class="text-center">@item.MinimumAmount</td>
            <td class="text-center">@item.Percent%</td>            
            <td class="text-center">@(item.DisplayOrder.HasValue ? item.DisplayOrder.Value.ToString() : string.Empty)</td>
            <td class="text-center">
                @if (item.FromDate < DateTime.Now && item.ToDate > DateTime.Now)
                {
                    <span class="label label-outline label-success">Si</span>
                }
                else
                {
                    <span class="label label-outline label-danger">No</span>
                }
            </td>
            <td class="text-center">
                @if (item.Active)
                {
                    <span class="label label-outline label-success">Si</span>
                }
                else
                {
                    <span class="label label-outline label-danger">No</span>
                }
            </td>
            <td class="text-center">
                @if (item.StoreType != (int)StoreTypeEnum.NotPublished)
                {
                    switch (item.StoreType)
                    {
                        case ((int)StoreTypeEnum.WholeSalerOnly):
                            {
                                <span class="label label-outline label-success">Mayorista</span>
                            }
                            break;

                        case ((int)StoreTypeEnum.RetailerOnly):
                            {
                                <span class="label label-outline label-success">Minorista</span>
                            }
                            break;

                        case ((int)StoreTypeEnum.PublishedForAll):
                            {
                                <span class="label label-outline label-success">Mayorista y minorista</span>
                            }
                            break;
                        default:
                            break;
                    }
                }
                else
                {
                    <span class="label label-outline label-danger">No publicado</span>
                }
            </td>
            <td class="actions text-center">
                <a href="/BankInterest/BankInterestUpdate/@item.BankInterestId" class="btn btn-sm btn-icon btn-pure btn-default on-default edit-row"
                   data-toggle="tooltip" data-original-title="Editar"><i class="icon wb-edit" aria-hidden="true"></i></a>
                <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row"
                   data-toggle="tooltip" data-original-title="Eliminar" data-rowid="@item.BankInterestId" onclick="fDeleteDialog(@item.BankInterestId)"><i class="icon wb-trash" aria-hidden="true"></i></a>
            </td>
        </tr>
    }
    </tbody>
</table>